<?
class javascript_ui{
	var $debug_mode = 0;
	var $export_list = array();
	var $export_file_list = array();
	var $request_type = "GET";
	var $remote_uri = "";
	var $javascript_code;
	var $show_loding=false;
	var $loaded= TRUE;

	function get_common_js() {
		global $system;
		if ($this->debug_mode){$debug_mode='true';}else{$debug_mode='false';}
		$html=<<<eof
		// remote scripting library
		// (c) copyright 2005 modernmethod, inc
		var sajax_debug_mode = $debug_mode;
		var sajax_request_type = "$this->request_type";
		
		function view_wait(){
		thisDiv = document.getElementById("wait_div");
		thisDiv.style.display = "block";
		}
		function hide_wait(){
		thisDiv = document.getElementById("wait_div");
		thisDiv.style.display = "none";
		}
		function sajax_debug(text) {
			if (sajax_debug_mode)
				alert("RSD: " + text)
		}
 		function sajax_init_object() {
 			sajax_debug("sajax_init_object() called..")
 			
 			var A;
			try {
				A=new ActiveXObject("Msxml2.XMLHTTP");
			} catch (e) {
				try {
					A=new ActiveXObject("Microsoft.XMLHTTP");
				} catch (oc) {
					A=null;
				
				}
			}
			if(!A && typeof XMLHttpRequest != "undefined")
				A = new XMLHttpRequest();
				
			if (!A)
				sajax_debug("Could not create connection object.");
			return A;
		}
		function sajax_do_call(func_name, args) {
			var i, x, n;
			var uri;
			var post_data;
			
			uri = "$this->remote_uri";
		
			if (sajax_request_type == "GET") {
			
				if (uri.indexOf("?") == -1) {
					uri = uri + "?rs=" + escape(func_name);
					
				}else{
					uri = uri + "&rs=" + escape(func_name);
				}
				for (i = 0; i < args.length-1; i++){
					uri = uri + "&rsargs[]=" + escape(args[i]);
					
				}		
				uri = uri + "&rsrnd=" + new Date().getTime();
			
				post_data = null;
			} else {
				post_data = "rs=" + escape(func_name);
				for (i = 0; i < args.length-1; i++) 
					post_data = post_data + "&rsargs[]=" + escape(args[i]);
			}
			
			x = sajax_init_object();
			x.open(sajax_request_type, uri, true);
			if (sajax_request_type == "POST") {
			x.setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
             x.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			}
			x.onreadystatechange = function() {
			
				if (x.readyState != 4){
				
					return;}
						
				sajax_debug("received " + x.responseText);
				hide_wait();
				var status;
				var data;
				status = x.responseText.charAt(0);
				data = x.responseText.substring(2);
				//alert(data + " my alert");
				if (status == "-"){
					alert("Error: " + data);
				
				}else{
					args[args.length-1](data);
							
				}
			}
			x.send(post_data);
			sajax_debug(func_name + " uri = " + uri + "/post = " + post_data);
			sajax_debug(func_name + " waiting..");
			view_wait();
			delete x;
		}
		function insert_into_div(code,div_name){
			thisDiv = document.getElementById(div_name);
			thisDiv.innerHTML = code;
		}
		function update_div(div_name,function_name){
			thisDiv = document.getElementById(div_name);
			
			thisDiv.innerHTML = '<input type=\"text\" id=\"' + div_name + '_text\" name=\"' + div_name + '\" size=\"30\" value=\"' + thisDiv.innerHTML + '\"/>  <img onClick="x_' + function_name + '(\'' + div_name + '\',value(\'' + div_name + '_text\'),' + function_name + '_action)" src="{$system->config['images_rel_path']}aplay.gif" />';
			
			
		}
		function value(element){
			element_obj = document.getElementById(element);
			if (!element_obj.value){
				return element_obj.innerHTML;
			}else{
				return element_obj.value;
			}
		
		}
eof;
		return $html;

}


function get_one_stub($func_name) {

	$html =<<<eof
		// wrapper for  $func_name
		
		function x_$func_name() {
			sajax_do_call("$func_name",
				x_$func_name.arguments);
		}
eof;
	return $html;
}
function export() {
	
	$n = func_num_args();
	for ($i = 0; $i < $n; $i++) {
		$this->export_list[] = func_get_arg($i);
	}
	
}

function export_function($name,$code) {
	$this->export($name);
	$this->javascript_code.=<<<eof
	
	function {$name}_action(code){
		$code
	}
	
eof;
}

function get_export_link($name,$args=array()) {
	if (is_array($args)){
		foreach($args as $arg){
			if (is_array($arg)&&$arg[1]){
				$args_html.=$arg[0].',';
			}else{
				$args_html.='\''.$arg.'\',';
			}
		}
	}
	$html='onclick="x_'.$name.'('.$args_html.$name.'_action); return false;"';
	return $html;
}
/*this function print the handler of the ajax*/
function ajax_handler(){
	$mode = "";

	if (!empty($_GET["rs"]))
	$mode = "get";

	if (!empty($_POST["rs"]))
	$mode = "post";

	if (empty($mode))
	exit;

	if ($mode == "get") {
		// Bust cache in the head
		header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
		header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
		// always modified
		header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
		header ("Pragma: no-cache");                          // HTTP/1.0
		$func_name = $_GET["rs"];
		if (! empty($_GET["rsargs"]))
		$args = $_GET["rsargs"];
		else
		$args = array();
	}else {
		$func_name = $_POST["rs"];
		if (! empty($_POST["rsargs"]))
		$args = $_POST["rsargs"];
		else
		$args = array();
	}

	if (!in_array($func_name, $this->export_list)){
	
	$code.= "-:$func_name not callable";
	}else {
		$code.= "+:";
		$result = call_user_func_array($func_name, $args);
	/*
		foreach ($lang as $key => $value){
			$result = str_replace("{lang_$key}",$value,$result);
		}
	*/
	
	$code.= $result.$system->debug_html;

	}
	return $code;
}

function insert_javascript(){
	global $system,$lang;
		$html=$this->get_common_js();
		foreach ($this->export_list as $func) {
			$html .= $this->get_one_stub($func);
		}
		$html.=$this->javascript_code;
		
			$wait='Please wait';
			$loading='<div id="wait_div"></div>';
		if ($this->show_loding){
			$loading='<div id="wait_div" style="background-color: #BF2329;padding-right:2px;color:#ffffff;display:none;width:200px;position:absolute;z-index:3;">'.$wait.' ...<img src="'.$system->config["site_url"].'images/loading.gif" alt="" /></div>';
		}
		return '<script language="javascript">'.$html.'</script>'.$loading;
		
	}
	
}

$system->javascript->ui= new javascript_ui();

?>